C     **************************                                              
C     * PDE2D 9.4 MAIN PROGRAM *                                              
C     **************************                                              
C     *** 1D PROBLEM SOLVED (COLLOCATION METHOD) ***                          
C##############################################################################
C     Is double precision mode to be used?  Double precision is recommended   #
C     on 32-bit computers.                                                    #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If double precision mode is used, variables and functions assigned   +#
C     + names beginning with a letter in the range A-H or O-Z will be DOUBLE +#
C     + PRECISION, and you should use double precision constants and FORTRAN +#
C     + expressions throughout; otherwise such variables and functions will  +#
C     + be of type REAL.  In either case, variables and functions assigned   +#
C     + names beginning with I,J,K,L,M or N will be of INTEGER type.         +#
C     +                                                                      +#
C     + It is possible to convert a single precision PDE2D program to double +#
C     + precision after it has been created, using an editor.  Just change   +#
C     + all occurrences of "real" to "double precision"                      +#
C     +                    " tdp" to "dtdp"  (note leading blank)            +#
C     + Any user-written code or routines must be converted "by hand", of    +#
C     + course.  To convert from double to single, reverse the changes.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      implicit double precision (a-h,o-z)
      parameter (neqnmx=  99)
C##############################################################################
C     NXGRID = number of X-grid lines                                         #
C##############################################################################
      PARAMETER (NXGRID = 501)         
C##############################################################################
C     How many differential equations (NEQN) are there in your problem?       #
C##############################################################################
      PARAMETER (NEQN = 1)            
C        DIMENSIONS OF WORK ARRAYS                                            
C        SET TO 1 FOR AUTOMATIC ALLOCATION                                    
      PARAMETER (IRWK8Z=           1)
      PARAMETER (IIWK8Z=           1)
      PARAMETER (NXP8Z=1001,KDEG8Z=1)
C##############################################################################
C     The solution is saved on a uniform grid of NX+1 points                  #
C                        XA + I*(XB-XA)/NX                                    #
C     I=0,...,NX.  Enter a value for NX (suggested value = 50).               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to save the solution at an arbitrary user-specified set  +#
C     + of NX+1 points, enter -NX.                                           +#
C     +                                                                      +#
C     + If you set NEAR8Z=1 in the main program, the values saved at each    +#
C     + output point will actually be the solution as evaluated at a nearby  +#
C     + collocation or integration point.  For most problems this obviously  +#
C     + will produce less accurate output or plots, but for certain (rare)   +#
C     + problems, a solution component may be much less noisy when plotted   +#
C     + only at collocation or integration points.                           +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      PARAMETER (NX =        100)
C##############################################################################
C     The solution will be saved (for possible postprocessing) at the NSAVE+1 #
C     time points                                                             #
C                          T0 + K*(TF-T0)/NSAVE                               #
C     K=0,...,NSAVE.  Enter a value for NSAVE.                                #
C                                                                             #
C     If a user-specified constant time step is used, NSTEPS must be an       #
C     integer multiple of NSAVE.                                              #
C##############################################################################
      PARAMETER (NSAVE = 1)           
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal
      dimension xgrid(nxgrid),xout8z(0:nx),xcross(100),tout8z(0:nsave),u       
     &out(0:nx,2,neqn,0:nsave),xres8z(nxp8z),ures8z(neqn,nxp8z)                
      allocatable iwrk8z(:),rwrk8z(:)                                          
C      dimension iwrk8z(iiwk8z),rwrk8z(irwk8z)                                 
      character*40 title                                                       
      logical linear,crankn,noupdt,nodist,fillin,evcmpx,adapt,plot,lsqfi       
     &t,fdiff,econ8z,ncon8z,restrt,gridid                                      
      common/dtdp14/ sint8z(20),bint8z(20),slim8z(20),blim8z(20)               
      common/dtdp15/ evlr8z,ev0r,evli8z,ev0i,evcmpx                            
      common/dtdp16/ p8z,evr8z(50),evi8z(50)                                   
      common/dtdp19/ toler(neqnmx),adapt                                       
      common/dtdp30/ econ8z,ncon8z                                             
      common/dtdp42/ nxa8z,kd8z                                                
      common/dtdp43/ work8z(nxp8z+3)                                           
      common/dtdp45/ perdc(neqnmx)                                             
      common/dtdp46/ eps8z,cgtl8z,npmx8z,itype,near8z                          
      common/dtdp62/ amin8z(2*neqnmx),amax8z(2*neqnmx)                         
      common/dtdp75/ nx18z,xa,xb,uout                                          
      pi = 4.0*atan(1.d0)                                                      
      nxa8z = nxp8z                                                            
      nx18z = nx+1                                                             
      kd8z = kdeg8z                                                            
C##############################################################################
C     If you don't want to read the FINE PRINT, default NPROB.                #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to solve several similar problems in the same run, set   +#
C     + NPROB equal to the number of problems you want to solve.  Then NPROB +#
C     + loops through the main program will be done, with IPROB=1,...,NPROB, +#
C     + and you can make the problem parameters vary with IPROB.  NPROB      +#
C     + defaults to 1.                                                       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NPROB = 1                                                                
      do 78755 iprob=1,nprob                                                   
C##############################################################################
C     PDE2D solves the time-dependent system (note: U,F,G,U0 may be vectors,  #
C     C,RHO may be matrices):                                                 #
C                                                                             #
C              C(X,T,U,Ux)*d(U)/dT = F(X,T,U,Ux,Uxx)                          #
C                                                                             #
C     or the steady-state system:                                             #
C                                                                             #
C              F(X,U,Ux,Uxx) = 0                                              #
C                                                                             #
C     or the linear and homogeneous eigenvalue system:                        #
C                                                                             #
C              F(X,U,Ux,Uxx) = lambda*RHO(X)*U                                #
C                                                                             #
C     with boundary conditions:                                               #
C                                                                             #
C                  G(X,[T],U,Ux) = 0                                          #
C           (periodic boundary conditions are also permitted)                 #
C                                                                             #
C     at two X values.                                                        #
C                                                                             #
C     For time-dependent problems there are also initial conditions:          #
C                                                                             #
C                  U = U0(X)   at T=T0                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + A system of NEQN complex partial differential equations must be      +#
C     + written as a system of 2*NEQN real equations, by separating the      +#
C     + equations into their real and imaginary parts.  However, note that   +#
C     + the complex arithmetic abilities of FORTRAN can be used to simplify  +#
C     + this separation.  For example, the complex PDE:                      +#
C     +      I*Uxx - 1/(1+U**10) = 0,   where U = UR + UI*I                  +#
C     + would be difficult to split up analytically, but using FORTRAN       +#
C     + expressions it is easy:                                              +#
C     +   F1 = -UIxx -  REAL(1.0/(1.0+CMPLX(UR,UI)**10))                     +#
C     +   F2 =  URxx - AIMAG(1.0/(1.0+CMPLX(UR,UI)**10))                     +#
C     +                                                                      +#
C     + If your PDEs involve the solution at points other than X, the        +#
C     + function                                                             +#
C     +             (D)OLDSOL1(IDER,IEQ,XX,KDEG)                             +#
C     + will interpolate (using interpolation of degree KDEG=1,2 or 3) to XX +#
C     + the function saved in UOUT(*,IDER,IEQ,ISET) on the last time step or +#
C     + iteration (ISET) for which it has been saved.  Thus, for example, if +#
C     + IDER=1, this will return the latest value of component IEQ of the    +#
C     + solution at XX, assuming this has not been modified using UPRINT...  +#
C     + If your equations involve integrals of the solution, for example,    +#
C     + you can use (D)OLDSOL1 to approximate these using the solution from  +#
C     + the last time step or iteration.                                     +#
C     +                                                                      +#
C     + Note: For a steady-state problem, you must reset NOUT=1 if you want  +#
C     + to save the solution each iteration.                                 +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C     You may now define global parameters, which may be referenced in any    #
C     of the "FORTRAN expressions" you input throughout the rest of this      #
C     interactive session.  You will be prompted alternately for parameter    #
C     names and their values; enter a blank name when you are finished.       #
C                                                                             #
C     Parameter names are valid FORTRAN variable names, starting in           #
C     column 1.  Thus each name consists of 1 to 6 alphanumeric characters,   #
C     the first of which must be a letter.  If the first letter is in the     #
C     range I-N, the parameter must be an integer.                            #
C                                                                             #
C     Parameter values are either FORTRAN constants or FORTRAN expressions    #
C     involving only constants and global parameters defined on earlier       #
C     lines.  They may also be functions of the problem number IPROB, if      #
C     you are solving several similar problems in one run (NPROB > 1).  Note  #
C     that you are defining global CONSTANTS, not functions; e.g., parameter  #
C     values may not reference any of the independent or dependent variables  #
C     of your problem.                                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you define other parameters here later, using an editor, you must +#
C     + add them to COMMON block /PARM8Z/ everywhere this block appears, if  +#
C     + they are to be "global" parameters.                                  +#
C     +                                                                      +#
C     + The variable PI is already included as a global parameter, with an   +#
C     + accurate value 3.14159...                                            +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      E      =                                                                 
     & 40.0                                                                    
      r      =                                                                 
     & 0.1                                                                     
      sigma  =                                                                 
     & 0.2                                                                     
      Smax   =                                                                 
     & 100                                                                     
      Tfinal =                                                                 
     & 0.5                                                                     
C##############################################################################
C     A collocation finite element method is used, with cubic Hermite         #
C     basis functions on the subintervals defined by the grid points:         #
C              XGRID(1),XGRID(2),...,XGRID(NXGRID)                            #
C     You will first be prompted for NXGRID, the number of X-grid points,     #
C     then for XGRID(1),...,XGRID(NXGRID).  Any points defaulted will be      #
C     uniformly spaced between the points you define; the first and last      #
C     points cannot be defaulted.  The interval over which the PDE system     #
C     is to be solved is then:                                                #
C               XGRID(1) < X < XGRID(NXGRID)                                  #
C                                                                             #
C##############################################################################
      call dtdpwx(xgrid,nxgrid,0)                                              
C        XGRID DEFINED                                                         
      XGRID(1) =                                                               
     & 0                                                                       
      XGRID(NXGRID/2) =                                                       
     & E                                                                       
      XGRID(NXGRID) =                                                          
     & Smax                                                                    
      call dtdpwx(xgrid,nxgrid,1)                                              
C        *******TIME-DEPENDENT PROBLEM                                         
      itype = 2                                                                
C##############################################################################
C     Enter the initial time value (T0) and the final time value (TF), for    #
C     this time-dependent problem.  T0 defaults to 0.                         #
C                                                                             #
C     TF is not required to be greater than T0.                               #
C##############################################################################
      T0 = 0.0                                                                 
      T0 =                                                                     
     & Tfinal                                                                  
      TF =                                                                     
     & 0                                                                       
C##############################################################################
C     Is this a linear problem? ("linear" means all differential equations    #
C     and all boundary conditions are linear).  If you aren't sure, it is     #
C     safer to answer "no".                                                   #
C##############################################################################
      LINEAR = .TRUE.                                                          
C##############################################################################
C     Do you want the time step to be chosen adaptively?  If you answer       #
C     'yes', you will then be prompted to enter a value for TOLER(1), the     #
C     local relative time discretization error tolerance.  The default is     #
C     TOLER(1)=0.01.  If you answer 'no', a user-specified constant time step #
C     will be used.  We suggest that you answer 'yes' and default TOLER(1)    #
C     (although for certain linear problems, a constant time step may be much #
C     more efficient).                                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If a negative value is specified for TOLER(1), then ABS(TOLER(1)) is +#
C     + taken to be the "absolute" error tolerance.  If a system of PDEs is  +#
C     + solved, by default the error tolerance specified in TOLER(1) applies +#
C     + to all variables, but the error tolerance for the J-th variable can  +#
C     + be set individually by specifying a value for TOLER(J) using an      +#
C     + editor, after the end of the interactive session.                    +#
C     +                                                                      +#
C     + Each time step, two steps of size dt/2 are taken, and that solution  +#
C     + is compared with the result when one step of size dt is taken.  If   +#
C     + the maximum difference between the two answers is less than the      +#
C     + tolerance (for each variable), the time step dt is accepted (and the +#
C     + next step dt is doubled, if the agreement is "too" good); otherwise  +#
C     + dt is halved and the process is repeated.  Note that forcing the     +#
C     + local (one-step) error to be less than the tolerance does not        +#
C     + guarantee that the global (cumulative) error is less than that value.+#
C     + However, as the tolerance is decreased, the global error should      +#
C     + decrease correspondingly.                                            +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ADAPT = .TRUE.                                                           
      TOLER(1) = 0.0001                                                       
C##############################################################################
C     If you don't want to read the FINE PRINT, it is safe (though possibly   #
C     very inefficient) to enter 'no'.                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If your time-dependent problem is linear with all PDE and boundary   +#
C     + condition coefficients independent of time except inhomogeneous      +#
C     + terms, then a large savings in execution time may be possible if     +#
C     + this is recognized (the LU decomposition computed on the first step  +#
C     + can be used on subsequent steps).  Is this the case for your         +#
C     + problem?  (Caution: if you answer 'yes' when you should not, you     +#
C     + will get incorrect results with no warning.)                         +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NOUPDT = .FALSE.                                                         
C##############################################################################
C     The time stepsize will be chosen adaptively, between an upper limit     #
C     of DTMAX = (TF-T0)/NSTEPS and a lower limit of 0.0001*DTMAX.  Enter     #
C     a value for NSTEPS (the minimum number of steps).                       #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you later turn off adaptive time step control, the time stepsize  +#
C     + will be constant, DT = (TF-T0)/NSTEPS.                               +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NSTEPS =                                                                 
     & 50                                                                      
      dt = (tf-t0)/max(nsteps,1)                                               
C##############################################################################
C     If you don't want to read the FINE PRINT, enter 'no'.                   #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Is the Crank-Nicolson scheme to be used to discretize time?  If you  +#
C     + answer 'no', a backward Euler scheme will be used.                   +#
C     +                                                                      +#
C     + If a user-specified constant time step is chosen, the second order   +#
C     + Crank Nicolson method is recommended only for problems with very     +#
C     + well-behaved solutions, and the first order backward Euler scheme    +#
C     + should be used for more difficult problems.  In particular, do not   +#
C     + use the Crank Nicolson method if the left hand side of any PDE is    +#
C     + zero, for example, if a mixed elliptic/parabolic problem is solved.  +#
C     +                                                                      +#
C     + If adaptive time step control is chosen, however, an extrapolation   +#
C     + is done between the 1-step and 2-step answers which makes the Euler  +#
C     + method second order, and the Crank-Nicolson method strongly stable.  +#
C     + Thus in this case, both methods have second order accuracy, and both +#
C     + are strongly stable.                                                 +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      CRANKN = .TRUE.                                                          
      FDIFF = .FALSE.                                                          
C##############################################################################
C     You may calculate one or more integrals (over the entire region) of     #
C     some functions of the solution and its derivatives.  How many integrals #
C     (NINT), if any, do you want to calculate?                               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector SINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in SINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, SLIM8Z(I), for the I-th integral can be set        +#
C     + below in the main program.  The computations will then stop          +#
C     + gracefully whenever SINT8Z(I) > SLIM8Z(I), for any I=1...NINT.       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NINT =          0                                                        
C##############################################################################
C     You may calculate one or more boundary integrals (over the entire       #
C     boundary) of some functions of the solution and its derivatives.  How   #
C     many boundary integrals (NBINT), if any, do you want to calculate?      #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector BINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in BINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, BLIM8Z(I), for the I-th boundary integral can be   +#
C     + set below in the main program.  The computations will then stop      +#
C     + gracefully whenever BINT8Z(I) > BLIM8Z(I), for any I=1...NBINT.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NBINT =          0                                                       
C##############################################################################
C     If you don't want to read the FINE PRINT, enter 'no'.                   #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Normally, interpolation is done to approximate the initial values    +#
C     + using cubic Hermites.  Since some derivatives must be interpolated,  +#
C     + if the initial values are not smooth (ie, have large or infinite     +#
C     + derivatives), the resulting cubic interpolants may have undesired    +#
C     + noise or large spikes.  Do you want to compute a least squares       +#
C     + approximation to the initial values, rather than an interpolant?     +#
C     + The least squares fit is generally much smoother, but requires one   +#
C     + extra linear system solution.                                        +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      LSQFIT = .FALSE.                                                         
C##############################################################################
C     If you don't want to read the FINE PRINT, enter 'no'.                   #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Do you want to read the initial conditions from the restart file,    +#
C     + if it exists (and use the conditions supplied above if it does not   +#
C     + exist)?                                                              +#
C     +                                                                      +#
C     + If so, PDE2D will dump the final solution at the end of each run     +#
C     + into a restart file "pde2d.res".  Thus the usual procedure for       +#
C     + using this dump/restart option is to make sure there is no restart   +#
C     + file in your directory left over from a previous job, then the       +#
C     + first time you run this job, the initial conditions supplied above   +#
C     + will be used, but on the second and subsequent runs the restart file +#
C     + from the previous run will be used to define the initial conditions. +#
C     +                                                                      +#
C     + You can do all the "runs" in one program, by setting NPROB > 1.      +#
C     + Each pass through the DO loop, T0,TF,NSTEPS and possibly other       +#
C     + parameters may be varied, by making them functions of IPROB.         +#
C     +                                                                      +#
C     + If the 2D or 3D collocation method is used, the coordinate           +#
C     + transformation should not change between dump and restart.           +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      RESTRT = .FALSE.                                                         
C     GRIDID = .FALSE. IF FINITE ELEMENT GRID CHANGES BETWEEN DUMP, RESTART    
      GRIDID = .TRUE.                                                          
C##############################################################################
C     If you do not have periodic boundary conditions, enter IPERDC=0.        #
C                                                                             #
C     Enter IPERDC=1 for periodic conditions at X = XGRID(1),XGRID(NXGRID)    #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + When periodic boundary conditions are selected, they apply to all    +#
C     + variables by default.  To turn off periodic boundary conditions on   +#
C     + the I-th variable, set PERDC(I) to 0 below in the main program and   +#
C     + set the desired boundary conditions in subroutine GB8Z, "by hand".   +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      IPERDC =          0                                                      
C##############################################################################
C     The solution is saved on a uniform grid of NX+1 points, covering the    #
C     interval (XA,XB).  Enter values for XA,XB.  These variables are usually #
C     defaulted.                                                              #
C                                                                             #
C     The defaults are XA = XGRID(1), XB = XGRID(NXGRID)                      #
C                                                                             #
C##############################################################################
C        defaults for xa,xb                                                    
      xa = xgrid(1)                                                            
      xb = xgrid(nxgrid)                                                       
C        DEFINE XA,XB IMMEDIATELY BELOW:                                       
      call dtdpx1(nx,xa,xb,hx8z,xout8z,npts8z)                                 
C        *******allocate workspace                                             
      call dtdp1q(nxgrid,neqn,ii8z,ir8z)                                       
      if (iiwk8z.gt.1) ii8z = iiwk8z                                           
      if (irwk8z.gt.1) ir8z = irwk8z                                           
      allocate (iwrk8z(ii8z),rwrk8z(ir8z))                                     
C        *******DRAW GRID POINTS?                                              
      PLOT = .FALSE.                                                            
C        *******call pde solver                                                
      call dtdp1x(xgrid, nxgrid, neqn, nint, nbint, xout8z, uout, tout8z       
     &, iperdc, plot, lsqfit, fdiff, npts8z, t0, dt, nsteps, nout, nsave       
     &, crankn, noupdt, itype, linear, rwrk8z, ir8z, iwrk8z, ii8z, restr       
     &t, gridid)                                                               
      deallocate (iwrk8z,rwrk8z)                                               
C        *******read from restart file to array ures8z                         
C      call dtdpr1(1,xres8z,nxp8z,ures8z,neqn)                                 
C        *******write array ures8z back to restart file                        
C      call dtdpr1(2,xres8z,nxp8z,ures8z,neqn)                                 
C        *******call user-written postprocessor                                
      call postpr(tout8z,nsave,xout8z,nx,uout,neqn)                            
C        *******LINE PLOTS                                                     
C##############################################################################
C     Enter a value for IVAR, to select the variable to be plotted or         #
C     printed:                                                                #
C         IVAR = 1 means V  (possibly as modified by UPRINT,..)               #
C                2       Vx                                                   #
C##############################################################################
      IVAR =          1                                                        
C        X IS VARIABLE                                                         
      ics8z = 1                                                                
C##############################################################################
C     If you don't want to read the FINE PRINT, default ISET1,ISET2,ISINC.    #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + The tabular output or plots will be made at times:                   +#
C     +        T(K) = T0 + K*(TF-T0)/NSAVE                                   +#
C     + for    K = ISET1, ISET1+ISINC, ISET1+2*ISINC,..., ISET2              +#
C     + Enter values for ISET1, ISET2 and ISINC.                             +#
C     +                                                                      +#
C     + The default is ISET1=0, ISET2=NSAVE, ISINC=1, that is, the tabular   +#
C     + output or plots will be made at all time values for which the        +#
C     + solution has been saved.                                             +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ISET1 = NSAVE                                                           
      ISET2 = NSAVE                                                            
      ISINC = 1                                                                
C                                                                              
      alow = amin8z(ivar)                                                      
      ahigh = amax8z(ivar)                                                     
C##############################################################################
C     Specify the range (UMIN,UMAX) for the dependent variable axis.  UMIN    #
C     and UMAX are often defaulted.                                           #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + By default, each plot will be scaled to just fit in the plot area.   +#
C     + For a common scaling, you may want to set UMIN=ALOW, UMAX=AHIGH.     +#
C     + ALOW and AHIGH are the minimum and maximum values over all output    +#
C     + points and over all saved time steps or iterations.                  +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      UMIN = 0.0                                                               
      UMAX = 0.0                                                               
      UMIN =                                                                   
     & 0                                                                       
      UMAX =                                                                   
     & 60                                                                     
C##############################################################################
C     Enter a title, WITHOUT quotation marks.  A maximum of 40 characters     #
C     are allowed.  The default is no title.                                  #
C##############################################################################
      TITLE = ' '                                                              
      TITLE = 'U                                       '                       
      call dtdprx(tout8z,nsave,iset1,iset2,isinc)                              
      do 78756 is8z=iset1,iset2,isinc                                          
      call dtdpzp(ics8z,ivar,tout8z,nsave,xout8z,nx,uout,neqn,title,umin       
     &,umax,ix8z,is8z)                                                         
78756 continue                                                                 
C        *******TABULAR OUTPUT                                                 
C##############################################################################
C     Enter a value for IVAR, to select the variable to be plotted or         #
C     printed:                                                                #
C         IVAR = 1 means V  (possibly as modified by UPRINT,..)               #
C                2       Vx                                                   #
C##############################################################################
      IVAR =          1                                                        
      ivara8z = mod(ivar-1,2)+1                                                
      ivarb8z = (ivar-1)/2+1                                                   
C##############################################################################
C     If you don't want to read the FINE PRINT, default ISET1,ISET2,ISINC.    #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + The tabular output or plots will be made at times:                   +#
C     +        T(K) = T0 + K*(TF-T0)/NSAVE                                   +#
C     + for    K = ISET1, ISET1+ISINC, ISET1+2*ISINC,..., ISET2              +#
C     + Enter values for ISET1, ISET2 and ISINC.                             +#
C     +                                                                      +#
C     + The default is ISET1=0, ISET2=NSAVE, ISINC=1, that is, the tabular   +#
C     + output or plots will be made at all time values for which the        +#
C     + solution has been saved.                                             +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ISET1 = 0                                                                
      ISET2 = NSAVE                                                            
      ISINC = 1                                                                
C##############################################################################
C     Enter a title, WITHOUT quotation marks.  A maximum of 40 characters     #
C     are allowed.  The default is no title.                                  #
C##############################################################################
      TITLE = ' '                                                              
      TITLE = 'V                                       '                       
      call dtdprx(tout8z,nsave,iset1,iset2,isinc)                              
      do 78757 is8z=iset1,iset2,isinc                                          
      call dtdp1d(xout8z,uout(0,ivara8z,ivarb8z,is8z),npts8z,title,tout8       
     &z(is8z))                                                                 
78757 continue                                                                 
78755 continue                                                                 
      call endgks                                                              
      stop                                                                     
      end                                                                      
                                                                               
                                                                               
      subroutine pdes8z(yd8z,i8z,j8z,kint8z,x,t,uu8z)                          
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
C        un8z(1,I),un8z(2,I),... hold the (rarely used) values                 
C        of UI,UIx,... from the previous iteration or time step                
      common /dtdp4x/un8z(3,neqnmx)                                            
      common /dtdp11/normx                                                     
      double precision normx,uu8z(3,neqnmx)                                    
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal                     
      V  = uu8z(1, 1)                                                          
      Vx = uu8z(2, 1)                                                          
      Vxx= uu8z(3, 1)                                                          
                          if (i8z.eq.0) then                                   
      yd8z = 0.0                                                               
C##############################################################################
C     Enter FORTRAN expressions for the functions whose integrals are to be   #
C     calculated and printed.  They may be functions of                       #
C                                                                             #
C       X,V,Vx,Vxx and (if applicable) T                                      #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you only want to integrate a function over part of the interval,  +#
C     + define that function to be zero on the rest of the interval.         +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  INTEGRAL1 DEFINED           
C     if (kint8z.eq.1) yd8z =                                                  
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
C##############################################################################
C     Enter FORTRAN expressions for the functions whose "integrals" (sum      #
C     over two boundary points) are to be calculated and printed.  They may   #
C     be functions of                                                         #
C                                                                             #
C       X,V,Vx,Vxx and (if applicable) T                                      #
C                                                                             #
C     The unit outward normal, NORMx (=1 at right endpoint, -1 at left),      #
C     may also be referenced.                                                 #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you only want to "integrate" a function over one boundary point,  +#
C     + define that function to be zero at the other point.                  +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  BND. INTEGRAL1 DEFINED      
C     if (kint8z.eq.-1) yd8z =                                                 
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
                          else                                                 
C##############################################################################
C     Now enter FORTRAN expressions to define the PDE coefficients, which     #
C     may be functions of                                                     #
C                                                                             #
C        X,T,V,Vx,Vxx                                                         #
C                                                                             #
C     Recall that the PDE has the form                                        #
C                                                                             #
C                     C*d(V)/dT = F                                           #
C                                                                             #
C##############################################################################
                if (j8z.eq.0) then                                             
      yd8z = 0.0                                                               
C                                                  C DEFINED                   
      if (i8z.eq. -101) yd8z =                                                 
     & -1                                                                      
C                                                  F DEFINED                   
      if (i8z.eq.    1) yd8z =                                                 
     & 0.5*sigma**2*x**2*Vxx + r*x*Vx - r*V                                    
                else                                                           
                endif                                                          
                          endif                                                
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      function u8z(i8z,x,t0)                                                   
      implicit double precision (a-h,o-z)                                      
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal                     
      u8z = 0.0                                                                
C##############################################################################
C     Now the initial values must be defined using FORTRAN expressions.       #
C     They may be functions of X, and may also reference the initial time T0. #
C##############################################################################
C                                                  V0 DEFINED                  
      if (i8z.eq.    1) u8z =                                                  
     & max(0.d0,x-E)                                                           
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine gb8z(gd8z,ifac8z,i8z,j8z,x,t,uu8z)                            
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
      dimension uu8z(3,neqnmx)                                                 
C        un8z(1,I),un8z(2,I),... hold the (rarely used) values                 
C        of UI,UIx,... from the previous iteration or time step                
      common /dtdp4x/ un8z(3,neqnmx)                                           
      double precision none                                                    
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal                     
      none = dtdplx(2)                                                         
      V  = uu8z(1, 1)                                                          
      Vx = uu8z(2, 1)                                                          
      if (j8z.eq.0) gd8z = 0.0                                                 
C##############################################################################
C     Enter FORTRAN expressions to define the boundary condition functions,   #
C     which may be functions of                                               #
C                                                                             #
C              X,V,Vx and (if applicable) T                                   #
C                                                                             #
C     Recall that the boundary conditions have the form                       #
C                                                                             #
C                           G = 0                                             #
C                                                                             #
C     Enter NONE to indicate "no" boundary condition.                         #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If "no" boundary condition is specified, the PDE is enforced at a    +#
C     + point just inside the boundary (exactly on the boundary, if EPS8Z    +#
C     + is set to 0 in the main program).                                    +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
            if (ifac8z.eq. 1) then                                             
C##############################################################################
C                                                                             #
C     First define the boundary conditions at the point X = XGRID(1).         #
C##############################################################################
                          if (j8z.eq.0) then                                   
C                                                  G DEFINED                   
      if (i8z.eq.    1) gd8z =                                                 
     & V                                                                       
                          else                                                 
                          endif                                                
            endif                                                              
            if (ifac8z.eq. 2) then                                             
C##############################################################################
C                                                                             #
C     Now define the boundary conditions at the point X = XGRID(NXGRID).      #
C##############################################################################
                          if (j8z.eq.0) then                                   
C                                                  G DEFINED                   
      if (i8z.eq.    1) gd8z =                                                 
     & Vx-1                                                                    
                          else                                                 
                          endif                                                
            endif                                                              
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine pmod8z(x,t,uu8z,uprint,uxprnt)                                
      implicit double precision (a-h,o-z)                                      
      dimension uu8z(3,*),uprint(*),uxprnt(*)                                  
      common/dtdp14/sint(20),bint(20),slim8z(20),blim8z(20)                    
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal                     
      V  = uu8z(1, 1)                                                          
      Vx = uu8z(2, 1)                                                          
      Vxx= uu8z(3, 1)                                                          
C##############################################################################
C     If you don't want to read the FINE PRINT, default all of the following  #
C     variables.                                                              #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Normally, PDE2D saves the values of V,Vx at the output points.       +#
C     + If different variables are to be saved (for later printing or        +#
C     + plotting) the following functions can be used to re-define the       +#
C     + output variables:                                                    +#
C     +    define UPRINT(1) to replace  V                                    +#
C     +           UXPRNT(1)             Vx                                   +#
C     + Each function may be a function of                                   +#
C     +                                                                      +#
C     +    X,V,Vx,Vxx and (if applicable) T                                  +#
C     +                                                                      +#
C     + Each may also be a function of the integral estimates SINT(1),...,   +#
C     + BINT(1),...                                                          +#
C     +                                                                      +#
C     + The default for each variable is no change, for example, UPRINT(1)   +#
C     + defaults to V.  Enter FORTRAN expressions for each of the            +#
C     + following functions (or default).                                    +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C        DEFINE UPRINT(*),UXPRNT(*) HERE:                                      
      return                                                                   
      end                                                                      
C        dummy routines                                                        
      subroutine xy8z(i8z,iarc8z,s,x,y,s0,sf)                                  
      implicit double precision (a-h,o-z)                                      
      return                                                                   
      end                                                                      
      subroutine dis8z(x,y,ktri,triden,shape)                                  
      implicit double precision (a-h,o-z)                                      
      return                                                                   
      end                                                                      
      function fb8z(i8z,iarc8z,ktri,s,x,y,t)                                   
      implicit double precision (a-h,o-z)                                      
      fb8z = 0                                                                 
      return                                                                   
      end                                                                      
      function axis8z(i8z,x,y,z,ical8z)                                        
      implicit double precision (a-h,o-z)                                      
      axis8z = 0                                                               
      return                                                                   
      end                                                                      
      subroutine tran8z(itrans,x,y,z)                                          
      implicit double precision (a-h,o-z)                                      
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine postpr(tout,nsave,xout,nx,uout,neqn)                          
      implicit double precision (a-h,o-z)                                      
      dimension xout(0:nx),tout(0:nsave)                                       
      dimension uout(0:nx,2,neqn,0:nsave)                                      
      common/parm8z/ pi,E     ,r     ,sigma ,Smax  ,Tfinal                     
      common /dtdp27/ itask,npes,icomm                                         
      common /dtdp46/ eps8z,cgtl8z,npmx8z,itype,near8z                         
      data lun,lud/0,47/                                                       
      if (itask.gt.0) return                                                   
C     UOUT(I,IDER,IEQ,L) = U_IEQ,  if IDER=1                                   
C                          Ux_IEQ, if IDER=2                                   
C       (possibly as modified by UPRINT,..)                                    
C       at the point XOUT(I)                                                   
C       at time/iteration TOUT(L).                                             
C       ******* ADD POSTPROCESSING CODE HERE:                                  
C       IN THE EXAMPLE BELOW, MATLAB PLOTFILES pde2d.m,                        
C      pde2d.rdm CREATED (REMOVE  COMMENTS TO ACTIVATE)                      
      if (lun.eq.0) then                                                     
         lun = 46                                                            
         open (lun,file='pde2d.m')                                           
         open (lud,file='pde2d.rdm')                                         
         write (lun,*) 'fid = fopen(''pde2d.rdm'');'                         
      endif                                                                  
      do 78753 l=0,nsave                                                     
         if (tout(l).ne.dtdplx(2)) nsave0 = l                                
78753 continue                                                               
      write (lud,78754) nsave0                                               
      write (lud,78754) neqn                                                 
      write (lud,78754) nx                                                   
78754 format (i8)                                                            
      do 78755 i=0,nx                                                        
         write (lud,78760) xout(i)                                           
78755 continue                                                               
      do 78759 l=0,nsave0                                                    
         write (lud,78760) tout(l)                                           
         do 78758 ieq=1,neqn                                                 
         do 78757 ider=1,2                                                   
         do 78756 i=0,nx                                                     
            write (lud,78760) uout(i,ider,ieq,l)                             
78756    continue                                                            
78757    continue                                                            
78758    continue                                                            
78759 continue                                                               
78760 format (e16.8)                                                         
      write (lun,*) '% Read solution from pde2d.rdm'                         
      write (lun,*) 'NSAVE = fscanf(fid,''%g'',1);'                          
      write (lun,*) 'NEQN = fscanf(fid,''%g'',1);'                           
      write (lun,*) 'NX = fscanf(fid,''%g'',1);'                             
      if (itype.eq.2) then                                                   
         write (lun,*) 'L0 = 0;'                                             
      else                                                                   
         write (lun,*) 'L0 = 1;'                                             
      endif                                                                  
      write (lun,*) 'T = zeros(NSAVE+1,1);'                                  
      write (lun,*) 'X = zeros(NX+1,1);'                                     
      write (lun,*) 'U = zeros(NX+1,NSAVE+1,2,NEQN);'                        
      write (lun,*) 'for i=0:NX'                                             
      write (lun,*) '   X(i+1) = fscanf(fid,''%g'',1);'                      
      write (lun,*) 'end'                                                    
      write (lun,*) 'for l=0:NSAVE'                                          
      write (lun,*) 'T(l+1) = fscanf(fid,''%g'',1);'                         
      write (lun,*) 'for ieq=1:NEQN'                                         
      write (lun,*) 'for ider=1:2'                                           
      write (lun,*) 'for i=0:NX'                                             
      write (lun,*)                                                          
     & '   U(i+1,l+1,ider,ieq) = fscanf(fid,''%g'',1);'                      
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'xmin = min(X(:));'                                      
      write (lun,*) 'xmax = max(X(:));'                                      
      write (lun,*) '% Plots of each variable'                               
      write (lun,*) 'for IEQ=1:NEQN'                                         
      write (lun,*) '% Plot U_IEQ,  if IDER=1'                               
      write (lun,*) '%      Ux_IEQ, if IDER=2'                               
      write (lun,*) 'IDER = 1;'                                              
      write (lun,*) 'umin = min(min(U(:,L0+1:NSAVE+1,IDER,IEQ)));'           
      write (lun,*) 'umax = max(max(U(:,L0+1:NSAVE+1,IDER,IEQ)));'           
      write (lun,*) 'for L=L0:NSAVE'                                         
      write (lun,*) '   figure'                                              
      write (lun,*) '   plot(X,U(:,L+1,IDER,IEQ))'                           
      write (lun,*) '   axis([xmin xmax umin umax])'                         
      write (lun,*) '   xlabel(''X'')'                                       
      write (lun,*) '   ylabel([''U'',num2str(IEQ)])'                        
      write (lun,*) '   title(['' T = '',num2str(T(L+1))])'                  
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      return                                                                   
      end                                                                      
