C     **************************                                              
C     * PDE2D 9.2 MAIN PROGRAM *                                              
C     **************************                                              
C     *** 2D PROBLEM SOLVED (COLLOCATION METHOD) ***                          
C##############################################################################
C     Is double precision mode to be used?  Double precision is recommended   #
C     on 32-bit computers.                                                    #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If double precision mode is used, variables and functions assigned   +#
C     + names beginning with a letter in the range A-H or O-Z will be DOUBLE +#
C     + PRECISION, and you should use double precision constants and FORTRAN +#
C     + expressions throughout; otherwise such variables and functions will  +#
C     + be of type REAL.  In either case, variables and functions assigned   +#
C     + names beginning with I,J,K,L,M or N will be of INTEGER type.         +#
C     +                                                                      +#
C     + It is possible to convert a single precision PDE2D program to double +#
C     + precision after it has been created, using an editor.  Just change   +#
C     + all occurrences of "real" to "double precision"                      +#
C     +                    " tdp" to "dtdp"  (note leading blank)            +#
C     + Any user-written code or routines must be converted "by hand", of    +#
C     + course.  To convert from double to single, reverse the changes.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      implicit double precision (a-h,o-z)
      parameter (neqnmx=  99)
C##############################################################################
C     NP1GRID = number of P1-grid lines                                       #
C##############################################################################
C-----------------------------------------> INPUT FROM GUI <-------------------
      PARAMETER (NP1GRID = 20)        
C##############################################################################
C     NP2GRID = number of P2-grid lines                                       #
C##############################################################################
C-----------------------------------------> INPUT FROM GUI <-------------------
      PARAMETER (NP2GRID = 50)        
C##############################################################################
C     How many differential equations (NEQN) are there in your problem?       #
C##############################################################################
      PARAMETER (NEQN = 2)            
      parameter (np3grid = 1)
C        DIMENSIONS OF WORK ARRAYS                                            
C        SET TO 1 FOR AUTOMATIC ALLOCATION                                    
      PARAMETER (IRWK8Z=           1)
      PARAMETER (IIWK8Z=           1)
      PARAMETER (NXP8Z=101,NYP8Z=101,KDEG8Z=1,NZP8Z=KDEG8Z+1)
C##############################################################################
C     The solution is normally saved on an NP1+1 by NP2+1 rectangular grid    #
C     of points,                                                              #
C                    P1 = P1A + I*(P1B-P1A)/NP1,    I = 0,...,NP1             #
C                    P2 = P2A + J*(P2B-P2A)/NP2,    J = 0,...,NP2             #
C     Enter values for NP1 and NP2.  Suggested values: NP1=NP2=25.            #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to save the solution at an arbitrary user-specified set  +#
C     + of points, set NP2=0 and NP1+1=number of points.  In this case you   +#
C     + can request tabular output, but no plots can be made.                +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      PARAMETER (NP1 = 5)            
      PARAMETER (NP2 = 20)            
      PARAMETER (NSAVE = 1)
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2    
      dimension p1grid(np1grid),p2grid(np2grid),p3grid(np3grid),p1out8z(       
     &0:np1,0:np2),p2out8z(0:np1,0:np2),p3out8z(0:np1,0:np2),p1cross(100       
     &),p2cross(100),tout8z(0:nsave),uout8z(0:np1,0:np2,4*neqn,0:nsave),       
     &uout(0:np1,0:np2,4,neqn,0:nsave),xres8z(nxp8z),yres8z(nyp8z),zres8       
     &z(nzp8z),ures8z(neqn,nxp8z,nyp8z,nzp8z)                                  
      equivalence (uout,uout8z)                                                
      allocatable iwrk8z(:),rwrk8z(:)                                          
C      dimension iwrk8z(iiwk8z),rwrk8z(irwk8z)                                 
      character*40 title                                                       
      logical linear,crankn,noupdt,nodist,fillin,evcmpx,adapt,plot,lsqfi       
     &t,fdiff,solid,econ8z,ncon8z,restrt,gridid                                
      common/dtdp14/ sint8z(20),bint8z(20),slim8z(20),blim8z(20)               
      common/dtdp15/ evlr8z,ev0r,evli8z,ev0i,evcmpx                            
      common/dtdp16/ p8z,evr8z(50),evi8z(50)                                   
      common/dtdp19/ toler(neqnmx),adapt                                       
      common/dtdp30/ econ8z,ncon8z                                             
      common/dtdp45/ perdc(neqnmx)                                             
      common/dtdp46/ eps8z,cgtl8z,npmx8z,itype                                 
      common/dtdp52/ nxa8z,nya8z,nza8z,kd8z                                    
      common/dtdp53/ work8z(nxp8z*nyp8z*nzp8z+9)                               
      common/dtdp64/ amin8z(4*neqnmx),amax8z(4*neqnmx)                         
      pi = 4.0*atan(1.d0)                                                      
      zr8z = 0.0                                                               
      nxa8z = nxp8z                                                            
      nya8z = nyp8z                                                            
      nza8z = nzp8z                                                            
      kd8z = kdeg8z                                                            
C##############################################################################
C     If you don't want to read the FINE PRINT, default NPROB.                #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to solve several similar problems in the same run, set   +#
C     + NPROB equal to the number of problems you want to solve.  Then NPROB +#
C     + loops through the main program will be done, with IPROB=1,...,NPROB, +#
C     + and you can make the problem parameters vary with IPROB.  NPROB      +#
C     + defaults to 1.                                                       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NPROB = 1                                                                
      do 78755 iprob=1,nprob                                                   
C##############################################################################
C     You may now define global parameters, which may be referenced in any    #
C     of the "FORTRAN expressions" you input throughout the rest of this      #
C     interactive session.  You will be prompted alternately for parameter    #
C     names and their values; enter a blank name when you are finished.       #
C                                                                             #
C     Parameter names are valid FORTRAN variable names, starting in           #
C     column 1.  Thus each name consists of 1 to 6 alphanumeric characters,   #
C     the first of which must be a letter.  If the first letter is in the     #
C     range I-N, the parameter must be an integer.                            #
C                                                                             #
C     Parameter values are either FORTRAN constants or FORTRAN expressions    #
C     involving only constants and global parameters defined on earlier       #
C     lines.  They may also be functions of the problem number IPROB, if      #
C     you are solving several similar problems in one run (NPROB > 1).  Note  #
C     that you are defining global CONSTANTS, not functions; e.g., parameter  #
C     values may not reference any of the independent or dependent variables  #
C     of your problem.                                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you define other parameters here later, using an editor, you must +#
C     + add them to COMMON block /PARM8Z/ everywhere this block appears, if  +#
C     + they are to be "global" parameters.                                  +#
C     +                                                                      +#
C     + The variable PI is already included as a global parameter, with an   +#
C     + accurate value 3.14159...                                            +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C-----------------------------------------> INPUT FROM GUI <-------------------
      E      =                                                                 
     & 100                                                                     
      Rmu    =                                                                 
     & 0.2                                                                     
      R1     =                                                                 
     & 6                                                                       
      R2     =                                                                 
     & 10                                                                      
C##############################################################################
C     A collocation finite element method is used, with bi-cubic Hermite      #
C     basis functions on the elements (small rectangles) defined by the grid  #
C     points:                                                                 #
C               P1GRID(1),...,P1GRID(NP1GRID)                                 #
C               P2GRID(1),...,P2GRID(NP2GRID)                                 #
C     You will first be prompted for NP1GRID, the number of P1-grid points,   #
C     then for P1GRID(1),...,P1GRID(NP1GRID).  Any points defaulted will be   #
C     uniformly spaced between the points you define; the first and last      #
C     points cannot be defaulted.  Then you will be prompted similarly        #
C     for the number and values of the P2-grid points.  The limits on the     #
C     parameters are then:                                                    #
C               P1GRID(1) < P1 < P1GRID(NP1GRID)                              #
C               P2GRID(1) < P2 < P2GRID(NP2GRID)                              #
C                                                                             #
C##############################################################################
      call dtdpwx(p1grid,np1grid,0)                                            
      call dtdpwx(p2grid,np2grid,0)                                            
C        P1GRID DEFINED                                                        
C-----------------------------------------> INPUT FROM GUI <-------------------
      P1GRID(1) =                                                              
     & R1                                                                      
C-----------------------------------------> INPUT FROM GUI <-------------------
      P1GRID(NP1GRID) =                                                        
     & R2                                                                      
C        P2GRID DEFINED                                                        
C-----------------------------------------> INPUT FROM GUI <-------------------
      P2GRID(1) =                                                              
     & 0                                                                       
C-----------------------------------------> INPUT FROM GUI <-------------------
      P2GRID(NP2GRID) =                                                        
     & pi                                                                      
C                                                                              
      p3grid(1) = 0                                                            
      call dtdpwx(p1grid,np1grid,1)                                            
      call dtdpwx(p2grid,np2grid,1)                                            
C##############################################################################
C     If you don't want to read the FINE PRINT, enter ISOLVE = 1.             #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + The following linear system solvers are available:                   +#
C     +                                                                      +#
C     + 1. Sparse direct method                                              +#
C     +               Harwell Library routine MA27 (used by permission) is   +#
C     +               used to solve the (positive definite) "normal"         +#
C     +               equations A**T*A*x = A**T*b.  The normal equations,    +#
C     +               which are essentially the equations which would result +#
C     +               if a least squares finite element method were used     +#
C     +               instead of a collocation method, are substantially     +#
C     +               more ill-conditioned than the original system Ax = b,  +#
C     +               so it may be important to use high precision if this   +#
C     +               option is chosen.                                      +#
C     + 2. Frontal method                                                    +#
C     +               This is an out-of-core band solver.  If you want to    +#
C     +               override the default number of rows in the buffer (11),+#
C     +               set a new value for NPMX8Z in the main program.        +#
C     + 3. Jacobi conjugate gradient iterative method                        +#
C     +               A preconditioned conjugate gradient iterative method   +#
C     +               is used to solve the (positive definite) normal        +#
C     +               equations.  High precision is also important if this   +#
C     +               option is chosen.  (This solver is MPI-enhanced, if    +#
C     +               MPI is available.)  If you want to override the        +#
C     +               default convergence tolerance, set a new relative      +#
C     +               tolerance CGTL8Z in the main program.                  +#
C     + 4. Local solver (normal equations)                                   +#
C     + 5. Local solver (original equations)                                 +#
C     +               Choose these options ONLY if alterative linear system  +#
C     +               solvers have been installed locally.  See subroutines  +#
C     +               (D)TD3M, (D)TD3N in file (d)subs.f for instructions    +#
C     +               on how to add local solvers.                           +#
C     + 6. MPI-based parallel band solver                                    +#
C     +               This is a parallel solver which runs efficiently on    +#
C     +               multiple processor machines, under MPI.  It is a       +#
C     +               band solver, with the matrix distributed over the      +#
C     +               available processors.  Choose this option ONLY if the  +#
C     +               solver has been activated locally.  See subroutine     +#
C     +               (D)TD3O in file (d)subs.f for instructions on how to   +#
C     +               activate this solver and the MPI-enhancements to the   +#
C     +               conjugate gradient solver.                             +#
C     +                                                                      +#
C     + Enter ISOLVE = 1,2,3,4,5 or 6 to select a linear system solver.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ISOLVE =          1                                                      
C        *******STEADY-STATE PROBLEM                                           
      itype = 1                                                                
      t0 = 0.0                                                                 
      dt = 1.0                                                                 
      crankn = .false.                                                         
      noupdt = .false.                                                         
C##############################################################################
C     Is this a linear problem? ("linear" means all differential equations    #
C     and all boundary conditions are linear)                                 #
C##############################################################################
      LINEAR = .TRUE.                                                          
C        Number of Newton iterations                                           
      NSTEPS = 1                                                               
      FDIFF = .FALSE.                                                          
C##############################################################################
C     You may calculate one or more integrals (over the entire region) of     #
C     some functions of the solution and its derivatives.  How many integrals #
C     (NINT), if any, do you want to calculate?                               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector SINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in SINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, SLIM8Z(I), for the I-th integral can be set        +#
C     + below in the main program.  The computations will then stop          +#
C     + gracefully whenever SINT8Z(I) > SLIM8Z(I), for any I=1...NINT.       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C-----------------------------------------> INPUT FROM GUI <-------------------
      NINT =          1                                                        
C##############################################################################
C     You may calculate one or more boundary integrals (over the entire       #
C     boundary) of some functions of the solution and its derivatives.  How   #
C     many boundary integrals (NBINT), if any, do you want to calculate?      #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector BINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in BINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, BLIM8Z(I), for the I-th boundary integral can be   +#
C     + set below in the main program.  The computations will then stop      +#
C     + gracefully whenever BINT8Z(I) > BLIM8Z(I), for any I=1...NBINT.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NBINT =          0                                                       
      lsqfit = .false.                                                         
      RESTRT = .FALSE.                                                         
      GRIDID = .TRUE.                                                          
C##############################################################################
C     If you do not have any periodic boundary conditions, enter IPERDC=0.    #
C                                                                             #
C     Enter IPERDC=1 for periodic conditions at P1 = P1GRID(1),P1GRID(NP1GRID)#
C           IPERDC=2 for periodic conditions at P2 = P2GRID(1),P2GRID(NP2GRID)#
C           IPERDC=4 for periodic conditions on both P1 and P2                #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + When periodic boundary conditions are selected, they apply to all    +#
C     + variables by default.  To turn off periodic boundary conditions on   +#
C     + the I-th variable, set PERDC(I) to 0 (or another appropriate value   +#
C     + of IPERDC) below in the main program and set the desired boundary    +#
C     + conditions in subroutine GB8Z, "by hand".                            +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C-----------------------------------------> INPUT FROM GUI <-------------------
      IPERDC =          0                                                      
C##############################################################################
C     The solution is saved on an NP1+1 by NP2+1 rectangular grid covering    #
C     the rectangle (P1A,P1B) x (P2A,P2B).  Enter values for P1A,P1B,P2A,P2B. #
C     These variables are usually defaulted.                                  #
C                                                                             #
C     The defaults are P1A = P1GRID(1), P1B = P1GRID(NP1GRID)                 #
C                      P2A = P2GRID(1), P2B = P2GRID(NP2GRID)                 #
C                                                                             #
C##############################################################################
C        defaults for p1a,p1b,p2a,p2b                                          
      p1a = p1grid(1)                                                          
      p1b = p1grid(np1grid)                                                    
      p2a = p2grid(1)                                                          
      p2b = p2grid(np2grid)                                                    
C        DEFINE P1A,P1B,P2A,P2B HERE:                                          
      call dtdpx3(np1,np2,0,p1a,p1b,p2a,p2b,zr8z,zr8z,hp18z,hp28z,hp38z,       
     &p1out8z,p2out8z,p3out8z,npts8z)                                          
C        SOLUTION SAVED EVERY NOUT ITERATIONS                                  
      NOUT = NSTEPS                                                            
C        *******allocate workspace                                             
      call dtdpqx(np1grid,np2grid,np3grid,isolve,neqn,ii8z,ir8z,iperdc)        
      if (iiwk8z.gt.1) ii8z = iiwk8z                                           
      if (irwk8z.gt.1) ir8z = irwk8z                                           
      allocate (iwrk8z(ii8z),rwrk8z(ir8z))                                     
C        *******DRAW GRID LINES?                                               
      PLOT = .FALSE.                                                            
C        *******call pde solver                                                
      call dtdp3x(p1grid, p2grid, p3grid, np1grid,np2grid, -1, neqn, p1o       
     &ut8z, p2out8z, p3out8z, uout, tout8z, npts8z, t0, dt, nsteps, nout       
     &, nsave, crankn, noupdt, itype, linear, isolve, rwrk8z, ir8z, iwrk       
     &8z, ii8z, iperdc, plot, lsqfit, fdiff, nint, nbint, restrt, gridid       
     &)                                                                        
      deallocate (iwrk8z,rwrk8z)                                               
C        *******read from restart file to array ures8z                         
C      call dtdpr3(1,xres8z,nxp8z,yres8z,nyp8z,zres8z,nzp8z,ures8z,neqn)       
C        *******write array ures8z back to restart file                        
C      call dtdpr3(2,xres8z,nxp8z,yres8z,nyp8z,zres8z,nzp8z,ures8z,neqn)       
C        *******call user-written postprocessor                                
      call postpr(tout8z,nsave,p1out8z,p2out8z,np1,np2,uout,neqn)              
C        *******VECTOR PLOTS                                                   
C##############################################################################
C     Enter values for IVAR1, IVAR2 to select the components Vr1 and Vr2      #
C     of the vector to be plotted.                                            #
C      IVAR1,IVAR2 = 1 means U  (possibly as modified by UPRINT,...)          #
C                    2       Ux                                               #
C                    3       Uy                                               #
C                    4       V                                                #
C                    5       Vx                                               #
C                    6       Vy                                               #
C                                                                             #
C     Vr1 and Vr2 are assumed to be the components of the vector in           #
C     Cartesian coordinates.                                                  #
C##############################################################################
      IVAR1 =          1                                                       
      IVAR2 =          4                                                       
      ISET1 = 1                                                                
      ISET2 = NSAVE                                                            
      ISINC = 1                                                                
C##############################################################################
C     If you don't want to read the FINE PRINT, enter 'no'.                   #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Do you want to scale the axes on the plot so that the region is      +#
C     + undistorted?  Otherwise the axes will be scaled so that the figure   +#
C     + approximately fills the plot space.                                  +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NODIST = .TRUE.                                                         
C                                                                              
      ivr18z = ivar1 + (ivar1-1)/3                                             
      ivr28z = ivar2 + (ivar2-1)/3                                             
      a1mag = max(abs(amin8z(ivr18z)),abs(amax8z(ivr18z)))                     
      a2mag = max(abs(amin8z(ivr28z)),abs(amax8z(ivr28z)))                     
C##############################################################################
C     For the purpose of scaling the arrows, the ranges of the two components #
C     of the vector are assumed to be (-VR1MAG,VR1MAG) and (-VR2MAG,VR2MAG).  #
C     Enter values for VR1MAG and VR2MAG.  VR1MAG and VR2MAG are often        #
C     defaulted.                                                              #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + By default, VR1MAG and VR2MAG are the maxima of the absolute values  +#
C     + of the first and second components.  For a common scaling, you may   +#
C     + want to set VR1MAG=A1MAG, VR2MAG=A2MAG.  A1MAG, A2MAG are the        +#
C     + maxima of the absolute values over all output points and over all    +#
C     + saved time steps or iterations.                                      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      VR1MAG = 0.0                                                             
      VR2MAG = 0.0                                                             
C##############################################################################
C     Enter a title, WITHOUT quotation marks.  A maximum of 40 characters     #
C     are allowed.  The default is no title.                                  #
C##############################################################################
      TITLE = ' '                                                              
      TITLE = 'Displacements (U,V)                        '                   
      call dtdprx(tout8z,nsave,iset1,iset2,isinc)                              
      do 78760 is8z=iset1,iset2,isinc                                          
      call dtdplq(uout8z(0,0,ivr18z,is8z),uout8z(0,0,ivr28z,is8z),uout8z       
     &(0,0,4,is8z),np1,np2,0,p1a,p1b,p2a,p2b,zr8z,zr8z,3,ix8z,jy8z,0,tit       
     &le,vr1mag,vr2mag,zr8z,zr8z,nodist,tout8z(is8z),zr8z,zr8z,zr8z,zr8z       
     &,2,ical8z)                                                               
78760 continue                                                                 
78755 continue                                                                 
      call endgks                                                              
      stop                                                                     
      end                                                                      
                                                                               
                                                                               
      subroutine tran8z(itrans,p1,p2,p38z)                                     
      implicit double precision (a-h,o-z)                                      
      common /dtdp41/x,y,z8z,x1,x2,x3,y1,y2,y3,z1,z2,z3,x11,x21,x31,x12,       
     &x22,x32,x13,x23,x33,y11,y21,y31,y12,y22,y32,y13,y23,y33,z11,z21,z3       
     &1,z12,z22,z32,z13,z23,z33                                                
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
C##############################################################################
C     You can solve problems in your region only if you can describe it by    #
C                         X = X(P1,P2)                                        #
C                         Y = Y(P1,P2)                                        #
C     with constant limits on the parameters P1,P2.  If your region is        #
C     rectangular, enter ITRANS=0 and the trivial parameterization            #
C                         X = P1                                              #
C                         Y = P2                                              #
C     will be used.  Otherwise, you need to read the FINE PRINT below.        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If P1,P2 represent polar or other non-Cartesian coordinates, you can +#
C     + reference the Cartesian coordinates X,Y and derivatives of your      +#
C     + unknowns with respect to these coordinates, when you define your     +#
C     + PDE coefficients, boundary conditions, and volume and boundary       +#
C     + integrals, if you enter ITRANS .NE. 0.  Enter:                       +#
C     +   ITRANS = 1, if P1,P2 are polar coordinates, that is, if            +#
C     +               P1=R, P2=Theta, where    X = R*cos(Theta)              +#
C     +                                        Y = R*sin(Theta)              +#
C     +   ITRANS = -1, same as ITRANS=1, but P1=Theta, P2=R                  +#
C     +   ITRANS = 3, to define your own coordinate transformation.  In      +#
C     +               this case, you will be prompted to define X,Y and      +#
C     +               their first and second derivatives in terms of P1,P2.  +#
C     +               Because of symmetry, you will not be prompted for all  +#
C     +               of the second derivatives.  If you make a mistake in   +#
C     +               computing any of these derivatives, PDE2D will usually +#
C     +               be able to issue a warning message. (X1 = dX/dP1, etc) +#
C     +   ITRANS = -3, same as ITRANS=3, but you will only be prompted to    +#
C     +               define X,Y; their first and second derivatives will    +#
C     +               be approximated using finite differences.              +#
C     +   When ITRANS = -3 or 3, the first derivatives of X,Y must all be    +#
C     +   continuous.                                                        +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ITRANS =         1                                                      
C                                                                              
      z8z = p38z                                                               
      z3 = 1                                                                   
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine pdes8z(yd8z,i8z,j8z,kint8z,p1,p2,p38z,t,uu8z)                 
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
C        un8z(1,I),un8z(2,I),... hold the (rarely used) values                 
C        of UI,UI1,... from the previous iteration or time step                
      common /dtdp5x/un8z(10,neqnmx)                                           
      common /dtdp18/norm1,norm2,n38z                                          
      double precision norm1,norm2,n38z,normx,normy,nz8z                       
      dimension uu8z(10,neqnmx)                                                
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
      zr8z = 0.0                                                               
      U  = uu8z(1, 1)                                                          
      U1 = uu8z(2, 1)                                                          
      U2 = uu8z(3, 1)                                                          
      U11= uu8z(5, 1)                                                          
      U22= uu8z(6, 1)                                                          
      U12= uu8z(8, 1)                                                          
      U21= uu8z(8, 1)                                                          
      V  = uu8z(1, 2)                                                          
      V1 = uu8z(2, 2)                                                          
      V2 = uu8z(3, 2)                                                          
      V11= uu8z(5, 2)                                                          
      V22= uu8z(6, 2)                                                          
      V12= uu8z(8, 2)                                                          
      V21= uu8z(8, 2)                                                          
      call dtdpcd(p1,p2,p38z)                                                  
      call dtdpcb(p1,p2,p38z,norm1,norm2,n38z,x,y,z8z,normx,normy,nz8z,3       
     &)                                                                        
      call dtdpcc(p1,p2,p38z,                                                  
     &          U1,U2,zr8z,U11,U22,zr8z,U12,zr8z,zr8z,                         
     & x,y,z8z,Ux,Uy,uz8z,Uxx,Uyy,uzz8z,Uxy,uxz8z,uyz8z,                       
     & Uyx,uzx8z,uzy8z,dvol,darea)                                             
      Unorm = Ux*normx + Uy*normy                                              
      call dtdpcc(p1,p2,p38z,                                                  
     &          V1,V2,zr8z,V11,V22,zr8z,V12,zr8z,zr8z,                         
     & x,y,z8z,Vx,Vy,uz8z,Vxx,Vyy,uzz8z,Vxy,uxz8z,uyz8z,                       
     & Vyx,uzx8z,uzy8z,dvol,darea)                                             
      Vnorm = Vx*normx + Vy*normy                                              
                          if (i8z.eq.0) then                                   
      yd8z = 0.0                                                               
C##############################################################################
C     Enter FORTRAN expressions for the functions whose integrals are to be   #
C     calculated and printed.  They may be functions of                       #
C                                                                             #
C        X,Y,U,Ux,Uy,Uxx,Uyy,Uxy                                              #
C            V,Vx,Vy,Vxx,Vyy,Vxy and (if applicable) T                        #
C                                                                             #
C     The parameters P1,P2 and derivatives with respect to these may also     #
C     be referenced (U1 = dU/dP1, etc):                                       #
C           U1,U2,U11,U22,U12                                                 #
C           V1,V2,V11,V22,V12                                                 #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you only want to integrate a function over part of the region,    +#
C     + define that function to be zero in the rest of the region.           +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  INTEGRAL1 DEFINED           
      if (kint8z.eq.1) yd8z =                                                  
     & V
C##############################################################################
C     Enter FORTRAN expressions for the functions whose integrals are to be   #
C     calculated and printed.  They may be functions of                       #
C                                                                             #
C        X,Y,U,Ux,Uy,Uxx,Uyy,Uxy                                              #
C            V,Vx,Vy,Vxx,Vyy,Vxy and (if applicable) T                        #
C                                                                             #
C     The components (NORMx,NORMy) of the unit outward normal vector          #
C     may also be referenced.                                                 #
C                                                                             #
C     The parameters P1,P2 and derivatives with respect to these may also     #
C     be referenced:                                                          #
C           U1,U2,U11,U22,U12                                                 #
C           V1,V2,V11,V22,V12                                                 #
C     You can also reference the normal derivatives Unorm,Vnorm.              #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you only want to integrate a function over part of the boundary,  +#
C     + define that function to be zero on the rest of the boundary.         +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  BND. INTEGRAL1 DEFINED      
C     if (kint8z.eq.-1) yd8z =                                                 
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
      if (kint8z.gt.0) yd8z = yd8z*dvol                                        
      if (kint8z.lt.0) yd8z = yd8z*darea                                       
                          else                                                 
C##############################################################################
C     Now enter FORTRAN expressions to define the PDE coefficients, which     #
C     may be functions of                                                     #
C                                                                             #
C        X,Y,U,Ux,Uy,Uxx,Uyy,Uxy                                              #
C            V,Vx,Vy,Vxx,Vyy,Vxy                                              #
C                                                                             #
C     and, in some cases, of the parameter T.                                 #
C                                                                             #
C     Recall that the PDEs have the form                                      #
C                                                                             #
C                        F1 = 0                                               #
C                        F2 = 0                                               #
C                                                                             #
C     The parameters P1,P2 and derivatives with respect to these may also     #
C     be referenced (U1 = dU/dP1, etc):                                       #
C           U1,U2,U11,U22,U12                                                 #
C           V1,V2,V11,V22,V12                                                 #
C##############################################################################
                if (j8z.eq.0) then                                             
      yd8z = 0.0                                                               
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  F1 DEFINED                  
      if (i8z.eq.    1) yd8z =                                                 
     & E/2/(1+Rmu)*(Uxx+Uyy+(Uxx+Vyx)/(1-2*Rmu))                              
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  F2 DEFINED                  
      if (i8z.eq.    2) yd8z =                                                 
     & E/2/(1+Rmu)*(Vxx+Vyy+(Uxy+Vyy)/(1-2*Rmu)) - 10                          
                else                                                           
                endif                                                          
                          endif                                                
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      function u8z(i8z,p1,p2,p38z,t0)                                          
      implicit double precision (a-h,o-z)                                      
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
      call dtdpcd(p1,p2,p38z)                                                  
      call dtdpcb(p1,p2,p38z,z18z,z28z,z38z,x,y,z8z,d18z,d28z,d38z,1)          
      u8z = 0.0                                                                
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine gb8z(gd8z,ifac8z,i8z,j8z,p1,p2,p38z,t,uu8z)                   
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
      dimension uu8z(10,neqnmx)                                                
C        un8z(1,I),un8z(2,I),... hold the (rarely used) values                 
C        of UI,UI1,... from the previous iteration or time step                
      common /dtdp5x/ un8z(10,neqnmx)                                          
      common /dtdp18/norm1,norm2,n38z                                          
      double precision none,norm1,norm2,n38z,normx,normy,nz8z                  
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
      none = dtdplx(2)                                                         
      zr8z = 0.0                                                               
      U  = uu8z(1, 1)                                                          
      U1 = uu8z(2, 1)                                                          
      U2 = uu8z(3, 1)                                                          
      V  = uu8z(1, 2)                                                          
      V1 = uu8z(2, 2)                                                          
      V2 = uu8z(3, 2)                                                          
      call dtdpcd(p1,p2,p38z)                                                  
      call dtdpcb(p1,p2,p38z,norm1,norm2,n38z,x,y,z8z,normx,normy,nz8z,3       
     &)                                                                        
      call dtdpcb(                                                             
     & p1,p2,p38z,U1,U2,zr8z,x,y,z8z,Ux,Uy,uz8z,2)                             
      Unorm = Ux*normx + Uy*normy                                              
      call dtdpcb(                                                             
     & p1,p2,p38z,V1,V2,zr8z,x,y,z8z,Vx,Vy,uz8z,2)                             
      Vnorm = Vx*normx + Vy*normy                                              
      if (j8z.eq.0) gd8z = 0.0                                                 
C##############################################################################
C     Enter FORTRAN expressions to define the boundary condition functions,   #
C     which may be functions of                                               #
C                                                                             #
C              X,Y,U,Ux,Uy,                                                   #
C                  V,Vx,Vy and (if applicable) T                              #
C                                                                             #
C     Recall that the boundary conditions have the form                       #
C                                                                             #
C                           G1 = 0                                            #
C                           G2 = 0                                            #
C                                                                             #
C     Enter NONE to indicate "no" boundary condition.                         #
C                                                                             #
C     The parameters P1,P2 and derivatives with respect to these may also     #
C     be referenced (U1 = dU/dP1, etc):                                       #
C                              U1,U2                                          #
C                              V1,V2                                          #
C     The components (NORMx,NORMy) of the unit outward normal vector          #
C     may also be referenced, as well as the normal derivatives Unorm,        #
C     Vnorm.                                                                  #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If "no" boundary condition is specified, the corresponding PDE is    +#
C     + enforced at points just inside the boundary (exactly on the          +#
C     + boundary, if EPS8Z is set to 0 in the main program).                 +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
       Sigxx = E*((1-Rmu)*Ux+Rmu*Vy)/(1-2*Rmu)/(1+Rmu)
       Sigxy = E*(Uy+Vx)/2./(1+Rmu)
       Sigyy = E*(Rmu*Ux+(1-Rmu)*Vy)/(1-2*Rmu)/(1+Rmu)
            if (ifac8z.eq. 1) then                                             
C##############################################################################
C                                                                             #
C     First define the boundary conditions on the face P1 = P1GRID(1).        #
C##############################################################################
                          if (j8z.eq.0) then                                   
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G1 DEFINED                  
      if (i8z.eq.    1) gd8z =                                                 
     & Sigxx*NORMx + Sigxy*NORMy
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G2 DEFINED                  
      if (i8z.eq.    2) gd8z =                                                 
     & Sigxy*NORMx + Sigyy*NORMy
                          else                                                 
                          endif                                                
            endif                                                              
            if (ifac8z.eq. 2) then                                             
C##############################################################################
C                                                                             #
C     Now define the boundary conditions on the face P1 = P1GRID(NP1GRID).    #
C##############################################################################
                          if (j8z.eq.0) then                                   
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G1 DEFINED                  
      if (i8z.eq.    1) gd8z =                                                 
     & Sigxx*NORMx + Sigxy*NORMy
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G2 DEFINED                  
      if (i8z.eq.    2) gd8z =                                                 
     & Sigxy*NORMx + Sigyy*NORMy
                          else                                                 
                          endif                                                
            endif                                                              
            if (ifac8z.eq. 3) then                                             
C##############################################################################
C                                                                             #
C     Now define the boundary conditions on the face P2 = P2GRID(1).          #
C##############################################################################
                          if (j8z.eq.0) then                                   
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G1 DEFINED                  
      if (i8z.eq.    1) gd8z =                                                 
     & U                                                                       
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G2 DEFINED                  
      if (i8z.eq.    2) gd8z =                                                 
     & V                                                                       
                          else                                                 
                          endif                                                
            endif                                                              
            if (ifac8z.eq. 4) then                                             
C##############################################################################
C                                                                             #
C     Now define the boundary conditions on the face P2 = P2GRID(NP2GRID).    #
C##############################################################################
                          if (j8z.eq.0) then                                   
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G1 DEFINED                  
      if (i8z.eq.    1) gd8z =                                                 
     & U                                                                       
C-----------------------------------------> INPUT FROM GUI <-------------------
C                                                  G2 DEFINED                  
      if (i8z.eq.    2) gd8z =                                                 
     & V                                                                       
                          else                                                 
                          endif                                                
            endif                                                              
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine pmod8z(p1,p2,p38z,t,uu8z,uprint,uxprnt,uyprnt,uzpr8z)         
      implicit double precision (a-h,o-z)                                      
      dimension uu8z(10,*),uprint(*),uxprnt(*),uyprnt(*),uzpr8z(*)             
      common/dtdp14/sint(20),bint(20),slim8z(20),blim8z(20)                    
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
      zr8z = 0.0                                                               
      U  = uu8z(1, 1)                                                          
      U1 = uu8z(2, 1)                                                          
      U2 = uu8z(3, 1)                                                          
      U11= uu8z(5, 1)                                                          
      U22= uu8z(6, 1)                                                          
      U12= uu8z(8, 1)                                                          
      U21= uu8z(8, 1)                                                          
      V  = uu8z(1, 2)                                                          
      V1 = uu8z(2, 2)                                                          
      V2 = uu8z(3, 2)                                                          
      V11= uu8z(5, 2)                                                          
      V22= uu8z(6, 2)                                                          
      V12= uu8z(8, 2)                                                          
      V21= uu8z(8, 2)                                                          
      call dtdpcd(p1,p2,p38z)                                                  
      call dtdpcc(p1,p2,p38z,                                                  
     &          U1,U2,zr8z,U11,U22,zr8z,U12,zr8z,zr8z,                         
     & x,y,z8z,Ux,Uy,uz8z,Uxx,Uyy,uzz8z,Uxy,uxz8z,uyz8z,                       
     & Uyx,uzx8z,uzy8z,dvol8z,dare8z)                                          
      uxprnt( 1) = Ux                                                          
      uyprnt( 1) = Uy                                                          
      call dtdpcc(p1,p2,p38z,                                                  
     &          V1,V2,zr8z,V11,V22,zr8z,V12,zr8z,zr8z,                         
     & x,y,z8z,Vx,Vy,uz8z,Vxx,Vyy,uzz8z,Vxy,uxz8z,uyz8z,                       
     & Vyx,uzx8z,uzy8z,dvol8z,dare8z)                                          
      uxprnt( 2) = Vx                                                          
      uyprnt( 2) = Vy                                                          
C##############################################################################
C     If you don't want to read the FINE PRINT, default all of the following  #
C     variables.                                                              #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Normally, PDE2D saves the values of U,Ux,Uy,V,Vx,Vy at               +#
C     + the output points.  If different variables are to be saved (for      +#
C     + later printing or plotting) the following functions can be used to   +#
C     + re-define the output variables:                                      +#
C     +    define UPRINT(1) to replace  U                                    +#
C     +           UXPRNT(1)             Ux                                   +#
C     +           UYPRNT(1)             Uy                                   +#
C     +           UPRINT(2)             V                                    +#
C     +           UXPRNT(2)             Vx                                   +#
C     +           UYPRNT(2)             Vy                                   +#
C     + Each function may be a function of                                   +#
C     +                                                                      +#
C     +    X,Y,U,Ux,Uy,Uxx,Uyy,Uxy                                           +#
C     +        V,Vx,Vy,Vxx,Vyy,Vxy and (if applicable) T                     +#
C     +                                                                      +#
C     + Each may also be a function of the integral estimates SINT(1),...,   +#
C     + BINT(1),...                                                          +#
C     +                                                                      +#
C     + The parameters P1,P2 and derivatives with respect to these may also  +#
C     + be referenced (U1 = dU/dP1, etc):                                    +#
C     +       U1,U2,U11,U22,U12                                              +#
C     +       V1,V2,V11,V22,V12                                              +#
C     +                                                                      +#
C     + The default for each variable is no change, for example, UPRINT(1)   +#
C     + defaults to U.  Enter FORTRAN expressions for each of the            +#
C     + following functions (or default).                                    +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C        DEFINE UPRINT(*),UXPRNT(*),UYPRNT(*) HERE:                            
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      function axis8z(i8z,p1,p2,p38z,ical8z)                                   
      implicit double precision (a-h,o-z)                                      
      call dtdpcd(p1,p2,p38z)                                                  
      call dtdpcb(p1,p2,p38z,z18z,z28z,z38z,x,y,z8z,d18z,d28z,d38z,1)          
      if (i8z.eq.1) axis8z = x                                                 
      if (i8z.eq.2) axis8z = y                                                 
      return                                                                   
      end                                                                      
C        dummy routines                                                        
      subroutine xy8z(i8z,iarc8z,s,x,y,s0,sf)                                  
      implicit double precision (a-h,o-z)                                      
      return                                                                   
      end                                                                      
      subroutine dis8z(x,y,ktri,triden,shape)                                  
      implicit double precision (a-h,o-z)                                      
      return                                                                   
      end                                                                      
      function fb8z(i8z,iarc8z,ktri,s,x,y,t)                                   
      implicit double precision (a-h,o-z)                                      
      fb8z = 0                                                                 
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine postpr(tout,nsave,p1out,p2out,np1,np2,uout,neqn)              
      implicit double precision (a-h,o-z)                                      
      dimension p1out(0:np1,0:np2),p2out(0:np1,0:np2),tout(0:nsave)            
      dimension uout(0:np1,0:np2,4,neqn,0:nsave)                               
      common/parm8z/ pi,E     ,Rmu   ,R1    ,R2                                
      common /dtdp27/ itask,npes,icomm                                         
      common /dtdp46/ eps8z,cgtl8z,npmx8z,itype                                
      data lun,lud/0,47/                                                       
      if (itask.gt.0) return                                                   
C     UOUT(I,J,IDER,IEQ,L) = U-sub-IEQ,  if IDER=1                             
C                            Ux-sub-IEQ, if IDER=2                             
C                            Uy-sub-IEQ, if IDER=3                             
C       (possibly as modified by UPRINT,..)                                    
C       at the point (P1OUT(I,J) , P2OUT(I,J))                                 
C       at time/iteration TOUT(L).                                             
C       ******* ADD POSTPROCESSING CODE HERE:                                  
C       IN THE EXAMPLE BELOW, MATLAB PLOTFILES pde2d.m,                        
C      pde2d.rdm CREATED (REMOVE C! COMMENTS TO ACTIVATE)                      
C!      if (lun.eq.0) then                                                     
C!         lun = 46                                                            
C!         open (lun,file='pde2d.m')                                           
C!         open (lud,file='pde2d.rdm')                                         
C!      endif                                                                  
C!      do 78753 l=0,nsave                                                     
C!         if (tout(l).ne.dtdplx(2)) nsave0 = l                                
C!78753 continue                                                               
C!      write (lud,78754) nsave0                                               
C!      write (lud,78754) neqn                                                 
C!      write (lud,78754) np1                                                  
C!      write (lud,78754) np2                                                  
C!78754 format (i8)                                                            
C!      do 78756 i=0,np1                                                       
C!      do 78755 j=0,np2                                                       
C!         p1 = p1out(i,j)                                                     
C!         p2 = p2out(i,j)                                                     
C!         p38z = 0.0                                                          
C!         call dtdpcd(p1,p2,p38z)                                             
C!         call dtdpcb(p1,p2,p38z,z18z,z28z,z38z,x,y,z8z,                      
C!     &   d18z,d28z,d38z,1)                                                   
C!         write (lud,78762) p1,p2,x,y                                         
C!78755 continue                                                               
C!78756 continue                                                               
C!      do 78761 l=0,nsave0                                                    
C!         write (lud,78762) tout(l)                                           
C!         do 78760 ieq=1,neqn                                                 
C!         do 78759 ider=1,3                                                   
C!         do 78758 i=0,np1                                                    
C!         do 78757 j=0,np2                                                    
C!            write (lud,78762) uout(i,j,ider,ieq,l)                           
C!78757    continue                                                            
C!78758    continue                                                            
C!78759    continue                                                            
C!78760    continue                                                            
C!78761 continue                                                               
C!78762 format (e16.8)                                                         
C!      write (lun,*) '% Read solution from pde2d.rdm'                         
C!      write (lun,*) 'fid = fopen(''pde2d.rdm'');'                            
C!      write (lun,*) 'NSAVE = fscanf(fid,''%g'',1);'                          
C!      write (lun,*) 'NEQN = fscanf(fid,''%g'',1);'                           
C!      write (lun,*) 'NP1 = fscanf(fid,''%g'',1);'                            
C!      write (lun,*) 'NP2 = fscanf(fid,''%g'',1);'                            
C!      if (itype.eq.2) then                                                   
C!         write (lun,*) 'L0 = 0;'                                             
C!      else                                                                   
C!         write (lun,*) 'L0 = 1;'                                             
C!      endif                                                                  
C!      write (lun,*) 'T = zeros(NSAVE+1,1);'                                  
C!      write (lun,*) 'P1 = zeros(NP2+1,NP1+1);'                               
C!      write (lun,*) 'P2 = zeros(NP2+1,NP1+1);'                               
C!      write (lun,*) 'X = zeros(NP2+1,NP1+1);'                                
C!      write (lun,*) 'Y = zeros(NP2+1,NP1+1);'                                
C!      write (lun,*) 'U = zeros(NP2+1,NP1+1,NSAVE+1,3,NEQN);'                 
C!      write (lun,*) 'for i=0:NP1'                                            
C!      write (lun,*) 'for j=0:NP2'                                            
C!      write (lun,*) '   P1(j+1,i+1) = fscanf(fid,''%g'',1);'                 
C!      write (lun,*) '   P2(j+1,i+1) = fscanf(fid,''%g'',1);'                 
C!      write (lun,*) '   X(j+1,i+1) = fscanf(fid,''%g'',1);'                  
C!      write (lun,*) '   Y(j+1,i+1) = fscanf(fid,''%g'',1);'                  
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'for l=0:NSAVE'                                          
C!      write (lun,*) 'T(l+1) = fscanf(fid,''%g'',1);'                         
C!      write (lun,*) 'for ieq=1:NEQN'                                         
C!      write (lun,*) 'for ider=1:3'                                           
C!      write (lun,*) 'for i=0:NP1'                                            
C!      write (lun,*) 'for j=0:NP2'                                            
C!      write (lun,*)                                                          
C!     & '   U(j+1,i+1,l+1,ider,ieq) = fscanf(fid,''%g'',1);'                  
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'xmin = min(min(X(:,:)));'                               
C!      write (lun,*) 'xmax = max(max(X(:,:)));'                               
C!      write (lun,*) 'ymin = min(min(Y(:,:)));'                               
C!      write (lun,*) 'ymax = max(max(Y(:,:)));'                               
C!      write (lun,*) 'hx = 0.1*(xmax-xmin);'                                  
C!      write (lun,*) 'hy = 0.1*(ymax-ymin);'                                  
C!      write (lun,*) '% Surface plots of each variable'                       
C!      write (lun,*) 'for IEQ=1:NEQN'                                         
C!      write (lun,*) 'IDER = 1;'                                              
C!      write (lun,*)                                                          
C!     & 'umin = min(min(min(U(:,:,L0+1:NSAVE+1,IDER,IEQ))));'                 
C!      write (lun,*)                                                          
C!     & 'umax = max(max(max(U(:,:,L0+1:NSAVE+1,IDER,IEQ))));'                 
C!      write (lun,*) 'for L=L0:NSAVE'                                         
C!      write (lun,*) '   figure'                                              
C!      write (lun,*) '   surf(X,Y,U(:,:,L+1,IDER,IEQ))'                       
C!      write (lun,*) '   axis([xmin xmax ymin ymax umin umax])'               
C!      write (lun,*) '   xlabel(''X'')'                                       
C!      write (lun,*) '   ylabel(''Y'')'                                       
C!      write (lun,*) '   zlabel([''U'',num2str(IEQ)])'                        
C!      write (lun,*) '   title(['' T = '',num2str(T(L+1))])'                  
C!      write (lun,*) '   view(-37.5,30.0)'                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) 'end'                                                    
C!      write (lun,*) '% ******* Choose variables for vector plots'            
C!      write (lun,*) '% (see comments in POSTPR)'                             
C!      write (lun,*) 'IEQ1 = 1;'                                              
C!      write (lun,*) 'IDER1 = 2;'                                             
C!      write (lun,*) 'IEQ2 = 1;'                                              
C!      write (lun,*) 'IDER2 = 3;'                                             
C!      write (lun,*) 'for L=L0:NSAVE'                                         
C!      write (lun,*) '   figure'                                              
C!      write (lun,*) '   quiver(X,Y,U(:,:,L+1,IDER1,IEQ1), ...'               
C!      write (lun,*) '              U(:,:,L+1,IDER2,IEQ2))'                   
C!      write (lun,*) '   axis([xmin-hx xmax+hx ymin-hy ymax+hy])'             
C!      write (lun,*) '   xlabel(''X'')'                                       
C!      write (lun,*) '   ylabel(''Y'')'                                       
C!      write (lun,*) '   title(['' T = '',num2str(T(L+1))])'                  
C!      write (lun,*) 'end'                                                    
      return                                                                   
      end                                                                      
